characterOrderOut = "ARNDCQEGHILKMFPSTWYV";
characterOrderIn  = "ACDEFGHIKLMNPQRSTVWY"; /* do not change! */

charmapOut		  = {};
charmapIn		  = {};
charmap			  = {24,1};

for (k=0; k<20; k=k+1)
{
	charmapOut[characterOrderOut[k]] = k;
	charmapIn [characterOrderIn[k]] = k;
}

for (k=0; k<20; k=k+1)
{
	charmap[k] = charmapIn[characterOrderOut[k]];
}


SetDialogPrompt ("Matrix file:");
fscanf 			(PROMPT_FOR_FILE, "String,NMatrix,NMatrix", wm, _numericRateMatrix, equalFreqs);

inFile = LAST_FILE_PATH;

PopulateModelMatrix ("MMX", equalFreqs);

t=1;

scaleFactor = ({1,20}["1"])*
			  (MMX${20,20}["_MATRIX_ELEMENT_ROW_ != _MATRIX_ELEMENT_COLUMN_"]${20,20}["equalFreqs[_MATRIX_ELEMENT_ROW_]"])*({20,1}["1"]);
			  
fprintf (stdout, "Expected divergence level (e.g. 0.05 for 5%): ");
fscanf	(stdin,  "Number", divLevel);


t 		 = divLevel/scaleFactor[0];
MMXM 	 = MMX; /* evaluate the matrix */

for (r=0; r<20; r=r+1)
{
	diag = 0;
	for (c=0; c<20; c=c+1)
	{
		if (r!=c)
		{
			diag = diag + MMXM[r][c];
		}
	}
	MMXM[r][r] = -diag;
}

expMx = Exp (MMXM);

ChoiceList (expMxWrt, "Transition Matrix", 1, SKIP_NONE, "Do not write", "Do not write the transition probability matrix to a file",
													  "Write", "Save the transition probability matrix to a file");
													  
if (expMxWrt<0)
{
	return 0;
}			
if (expMxWrt==1)
{
	SetDialogPrompt ("Write transition matrix to:");
	fprintf (PROMPT_FOR_FILE, CLEAR_FILE, characterOrderIn, "\n", expMx);
}				

logOddMx = {24,24};

H 		 = 0;
E 		 = 0;
minScore = 1e20;

for (r=0; r<20; r=r+1)
{
	logOddMx [r][r] = (2*(Log2(equalFreqs[r]*expMx[r][r])-2*Log2(equalFreqs[r]))+0.5)$1;
	E = E + equalFreqs[r]^2 * logOddMx [r][r];
	H = H + (2*equalFreqs[r]*expMx[r][r]) * logOddMx[r][r];
	for (c=r+1; c<20; c=c+1)
	{
		logOddMx [r][c] = (2*(Log2(equalFreqs[r]*expMx[r][c]+equalFreqs[c]*expMx[c][r])-1-Log2(equalFreqs[r]*equalFreqs[c]))+0.5)$1;
		logOddMx [c][r] = logOddMx [r][c];
		E = E + equalFreqs[c] * equalFreqs[r] * logOddMx [r][c];
		H = H + (expMx[r][c]*equalFreqs[r]+equalFreqs[c]*expMx[c][r]) * logOddMx[r][c];
		minScore = Min (minScore, logOddMx [r][c]);
	}
	/* do the 'B' score */
	idx1 = 2;
	idx2 = 11;
	idx3 = 20;
	
	logOddMx [r][idx3] = (2*(Log2(equalFreqs[r]*expMx[r][idx1]+equalFreqs[idx1]*expMx[idx1][r]+	
							   equalFreqs[r]*expMx[r][idx2]+equalFreqs[idx2]*expMx[idx2][r])
						  -1-Log2(equalFreqs[r])-Log2(equalFreqs[idx1]+equalFreqs[idx2]))+0.5)$1;
	logOddMx [idx3][r] = logOddMx [r][idx3];
	
	/* do the 'BB' score */
	
	logOddMx [idx3][idx3] = (2*(Log2(2*equalFreqs[idx1]*expMx[idx1][idx1]+2*equalFreqs[idx2]*expMx[idx2][idx2]+
								equalFreqs[idx2]*expMx[idx2][idx1]+equalFreqs[idx1]*expMx[idx1][idx2])
							 -1-Log2(equalFreqs[idx1]^2+equalFreqs[idx2]^2+equalFreqs[idx2]*equalFreqs[idx1]))+0.5)$1;
	
	
	/* do the 'Z' score */
	idx1 = 3;
	idx2 = 13;
	idx3 = 21;
	
	logOddMx [r][idx3] = (2*(Log2(equalFreqs[r]*expMx[r][idx1]+equalFreqs[idx1]*expMx[idx1][r]+	
							   equalFreqs[r]*expMx[r][idx2]+equalFreqs[idx2]*expMx[idx2][r])
						  -1-Log2(equalFreqs[r])-Log2(equalFreqs[idx1]+equalFreqs[idx2]))+0.5)$1;
	logOddMx [idx3][r] = logOddMx [r][idx3];


	/* do the 'ZZ' score */
	logOddMx [idx3][idx3] = (2*(Log2(2*equalFreqs[idx1]*expMx[idx1][idx1]+2*equalFreqs[idx2]*expMx[idx2][idx2]+
							equalFreqs[idx2]*expMx[idx2][idx1]+equalFreqs[idx1]*expMx[idx1][idx2])
						 -1-Log2(equalFreqs[idx1]^2+equalFreqs[idx2]^2+equalFreqs[idx2]*equalFreqs[idx1]))+0.5)$1;
							 
	/* do the 'smthX' score */
	scr1 = 0;
	for (c=0; c<20; c=c+1)
	{
		if (c!=r)
		{
			scr1 = scr1+equalFreqs[c]*expMx[c][r] + equalFreqs[r]*expMx[r][c];
		}
	}
	idx3 = 22;
	scr1 = (2*(Log2(scr1)-1-Log2(equalFreqs[r]*(1-equalFreqs[r])))+0.5)$1;
	logOddMx [r][idx3] = scr1;
	logOddMx [idx3][r] = scr1;

}

/* do the BZ score */

scr1 = equalFreqs[2]*expMx[2][3]+equalFreqs[3]*expMx[3][2]+
	   equalFreqs[2]*expMx[2][13]+equalFreqs[13]*expMx[13][2]+
	   equalFreqs[11]*expMx[11][3]+equalFreqs[3]*expMx[3][11]+
	   equalFreqs[11]*expMx[11][3]+equalFreqs[13]*expMx[13][11];
	 
scr2 = (equalFreqs[2]+equalFreqs[11])*(equalFreqs[3]+equalFreqs[11]);

logOddMx[20][21] = (2*(Log2(scr1)-1-Log2(scr2))+0.5)$1;
logOddMx[21][20] = logOddMx[20][21];

/* do the 'BX' score */

scr1 = 0;
for (c=0; c<20; c=c+1)
{
	if (c!=2 && c!=11)
	{
		scr1 = scr1+equalFreqs[c]*expMx[c][2] + equalFreqs[2]*expMx[2][c] + equalFreqs[c]*expMx[c][11] + equalFreqs[11]*expMx[11][c];
	}
}
scr1 = (2*(Log2(scr1)-1-Log2(equalFreqs[2]*(1-equalFreqs[2])+equalFreqs[11]*(1-equalFreqs[11])))+0.5)$1;
logOddMx [20][22] = scr1;
logOddMx [22][20] = scr1;

/* do the 'ZX' score */

scr1 = 0;
for (c=0; c<20; c=c+1)
{
	if (c!=3 && c!=13)
	{
		scr1 = scr1+equalFreqs[c]*expMx[c][3] + equalFreqs[3]*expMx[3][c] + equalFreqs[c]*expMx[c][13] + equalFreqs[13]*expMx[13][c];
	}
}
scr1 = (2*(Log2(scr1)-1-Log2(equalFreqs[3]*(1-equalFreqs[3])+equalFreqs[13]*(1-equalFreqs[13])))+0.5)$1;
logOddMx [21][22] = scr1;
logOddMx [22][21] = scr1;


/* do the 'XX' score */
scr1 = 0;
scr2 = 0;

for (r=0; r<20; r=r+1)
{
	for (c=0; c<20; c=c+1)
	{
		if (c!=r)
		{
			scr1 = scr1+equalFreqs[c]*expMx[c][r] + equalFreqs[r]*expMx[r][c];
			scr2 = scr2+equalFreqs[c]*equalFreqs[r];
		}
	}
}

scr1 			  = (2*(Log2(scr1)-1-Log2(scr2))+0.5)$1;
logOddMx [22][22] = scr1;


for (r=0; r<24; r=r+1)
{
	logOddMx[r][23] = minScore;
	logOddMx[23][r] = minScore;
}

logOddMx[23][23] = 1;

SetDialogPrompt ("Save matrix to:");

fprintf (PROMPT_FOR_FILE, CLEAR_FILE, KEEP_OPEN, "# Divergence level: ", divLevel, "\n# Matrix from: ", inFile, "\n# Expected score: ", E/2, " Entropy: ", H/2, " bits\n" );


filePath = LAST_FILE_PATH;

characterOrderOut = characterOrderOut + "BZX*";
charmap[20] = 20;
charmap[21] = 21;
charmap[22] = 22;
charmap[23] = 23;

logOddRemap = {24,24};

fprintf (filePath, "  ");
for (r=0; r<24; r=r+1)
{
	fprintf (filePath, "   ", characterOrderOut[r]);
}

for (r=0; r<24; r=r+1)
{
	fprintf (filePath, "\n", characterOrderOut[r], " ");
	rm = charmap[r];
	for (c=0; c<24; c=c+1)
	{
		fprintf (filePath, " ", Format(logOddMx[rm][charmap[c]],3,0));
		logOddRemap[r][c] = logOddMx[rm][charmap[c]];
	}
}

fprintf (filePath, CLOSE_FILE);
fscanf  (filePath, "Raw", out);
fprintf (stdout, out);

function Log2 (arg)
{
	return Log(arg)/Log(2);
}

function PopulateModelMatrix (ModelMatrixName&, EFV)
{
	ModelMatrixName = {20,20};
	for (ri = 0; ri < 20; ri = ri+1)
	{
		for (ci = ri+1; ci < 20; ci = ci+1)
		{
			ModelMatrixName[ri][ci] := _numericRateMatrix__[ri__][ci__] * equalFreqs[ci__] * t ;
			ModelMatrixName[ci][ri] := _numericRateMatrix__[ri__][ci__] * equalFreqs[ri__] * t;
		}
	}
	return 0;
}